﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.IO;
using System.Globalization;
using System.Diagnostics;
using System.Windows.Xps;
using System.IO.Packaging;
using System.Windows.Xps.Packaging;
using System.Windows.Markup;
using System.Drawing;
using Infragistics.Windows.Reporting;
using Microsoft.Win32;

namespace InfragisticsWPFReporting
{
	/// <summary>
	/// Interaktionslogik für MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public ObservableCollection<ValueSeries> Collection1
		{
			get;
			set;
		}

		public ObservableCollection<ValueSeries> Collection2
		{
			get;
			set;
		}


		public ObservableCollection<ValueSeries> Collection3
		{
			get;
			set;
		}

		public double GaugeValue1
		{
			get;
			set;
		}

		public double GaugeValue2
		{
			get;
			set;
		}

		public double GaugeValue3
		{
			get;
			set;
		}


		public MainWindow()
		{
			InitializeComponent();
			this.DataContext = this;
			Collection1 = new ObservableCollection<ValueSeries>();
			Collection2 = new ObservableCollection<ValueSeries>();
			Collection3 = new ObservableCollection<ValueSeries>();

			FillCollection();
		}

		private void FillCollection()
		{
			DateTime date = new DateTime(2011, 12, 31, 00, 00, 00);
			Random rdm = new Random();


			for (int i = 0; i < 10; i++)
			{
				date = date.AddDays(1);
				Collection1.Add(new ValueSeries(date, rdm.Next(100, 900) + rdm.NextDouble()));
			}

			date = new DateTime(2011, 12, 31, 00, 00, 00);

			for (int i = 0; i < 10; i++)
			{
				date = date.AddDays(1);
				Collection2.Add(new ValueSeries(date, rdm.Next(100, 900) + rdm.NextDouble()));
			}

			date = new DateTime(2011, 12, 31, 00, 00, 00);

			for (int i = 0; i < 10; i++)
			{
				date = date.AddDays(1);
				Collection3.Add(new ValueSeries(date, rdm.Next(100, 900) + rdm.NextDouble()));
			}

			GaugeValue1 = rdm.Next(0, 500) + rdm.NextDouble();
			GaugeValue2 = rdm.Next(0, 500) + rdm.NextDouble();
			GaugeValue3 = rdm.Next(0, 500) + rdm.NextDouble();
		}

		private ObservableCollection<ValueSeries> CreateRandomValueSeries()
		{
			ObservableCollection<ValueSeries> randomCollection;
			randomCollection = new ObservableCollection<ValueSeries>();

			DateTime date = new DateTime(2011, 12, 31, 00, 00, 00);
			Random rdm = new Random();


			for (int i = 0; i < 10; i++)
			{
				date = date.AddDays(1);
				randomCollection.Add(new ValueSeries(date, rdm.Next(100, 900) + rdm.NextDouble()));
			}

			return randomCollection;
		}

		private void ExportToXPS_Click(object sender, RoutedEventArgs e)
		{
			SaveFileDialog saveDlg = new SaveFileDialog();
			saveDlg.Filter = "XPS documents|*.xps";
			if (!saveDlg.ShowDialog().GetValueOrDefault())
				return;

			Report reportObj = CreateReport();

			reportObj.Export(OutputFormat.XPS, saveDlg.FileName);

			//optional Start Viewer
			Process.Start(saveDlg.FileName);
		}

		private void Preview_Click(object sender, RoutedEventArgs e)
		{

			Report reportObj = CreateReport();
			// Put report to preview control
			XamReportPreview.GeneratePreview(reportObj, false, false);

			tbiPreview.IsSelected = true;
		}

		private Report CreateReport()
		{
			// ------ Print Settings ---------------------------------------------------------------

			// Create report and add visual to print
			Report reportObj = new Report();

			reportObj.ReportSettings.Margin = new Thickness(50, 20, 50, 20);
			reportObj.PageHeaderTemplate = mainGrid.TryFindResource("PagePresenterHeaderTemplate") as DataTemplate;

			reportObj.PageFooterTemplate = mainGrid.TryFindResource("PagePresenterFooterTemplate") as DataTemplate;
			// Enable Landscape mode
			reportObj.ReportSettings.PageOrientation = Infragistics.Windows.Reporting.PageOrientation.Landscape;

			// First section with chart
			EmbeddedVisualReportSection section = new EmbeddedVisualReportSection(Grid);
			section.PageHeader = new MetaData()
			{
				PageName = "Grid Export",
				CurrentUser = "Dummy"
			};
			section.PageFooter = new MetaData()
			{
				PageName = "Test Export",
				CurrentUser = "Dummy"
			};

			//Second section also with chart
			EmbeddedVisualReportSection secSection = new EmbeddedVisualReportSection(SecondGrid);
			secSection.PageHeader = new MetaData()
			{
				PageName = "Grid Export",
				CurrentUser = "Dummy"
			};
			secSection.PageFooter = new MetaData()
			{
				PageName = "Test Export",
				CurrentUser = "Dummy"
			};

			// third section with chart
			EmbeddedVisualReportSection thirdSection = new EmbeddedVisualReportSection(ThirdGrid);
			thirdSection.PageHeader = new MetaData()
			{
				PageName = "Grid Export",
				CurrentUser = "Dummy"
			};
			thirdSection.PageFooter = new MetaData()
			{
				PageName = "Test Export",
				CurrentUser = "Dummy"
			};

			reportObj.Sections.Add(section);
			reportObj.Sections.Add(secSection);
			reportObj.Sections.Add(thirdSection);
			// ------ Print Settings ---------------------------------------------------------------

			return reportObj;
		}
	}

	class MetaData
	{

		public string PageName
		{
			get;
			set;
		}

		public DateTime PageDate
		{
			get
			{
				return DateTime.Now;
			}
		}

		public string CurrentUser
		{
			get;
			set;
		}
	}
}
